Loading...
Searching...
No Matches
InDegMap< GR > Class Template Reference
Data Structures » Maps » Graph Maps

## Detailed Description

template<typename GR>
class lemon::InDegMap< GR >

This map returns the in-degree of a node. Once it is constructed, the degrees are stored in a standard `NodeMap`, so each query is done in constant time. On the other hand, the values are updated automatically whenever the digraph changes.

Warning
  Besides `addNode()` and `addArc()`, a digraph structure may provide alternative ways to modify the digraph. The correct behavior of InDegMap is not guarantied if these additional features are used. For example, the functions changeSource(), changeTarget() and reverseArc() of ListDigraph will not update the degree values correctly.

See also
  OutDegMap

`#include <lemon/maps.h>`

## Public Types

typedef GR | Graph
| The graph type of InDegMap.
typedef Digraph::Node | Key
| The key type.
typedef int | Value
| The value type.

## Public Member Functions

| InDegMap (const Digraph &graph)
| Constructor.
int | operator[] (const Key &key) const
| Gives back the in-degree of a Node.

## Constructor & Destructor Documentation

## InDegMap()

template<typename GR>

InDegMap | ( | const Digraph & | graph | ) |

inline explicit

Constructor for creating an in-degree map.

## Member Function Documentation

## operator[]()

template<typename GR>

int operator[] | ( | const Key & | key | ) | const

inline

Gives back the in-degree of a Node.